# Contributing to vprof

Thanks for taking the time to contribute!

This is a set of guidelines for contributing to vprof. These are not rules!
Feel free to propose changes to this document in a pull request.

## How can I contribute?

### Spreading the word
* Tell your friends or co-workers about vprof.
* Write a blog post about vprof.
* Write a tutorial for vprof.

### Reporting bugs

* Before submitting bug report, please check if the problem has already been
reported.
* Use clear and descriptive title for the issue.
* Describe the exact steps to reproduce the problem.
* Describe behavior you observed after following the steps.
* Describe behavior you expect to see instead.
* Include screenshots if it helps to demonstrate the problem.
* Include version vprof, Python, name and version of OS you are using.

### Suggesting enchanchements
Before creating feature request, please check if the feature has already been
requested or implemented.

### Contributing code
* If you want to contribute a new feature, please create feature request first. Your new feature request can be out of vprof scope and might not be added to the project.
* Use clear and descriptive title for the pull request.
* New code should adhere to respective styleguides.
* Add unit and integration tests if necessary.
* All new code should be documented.

## Styleguide
* PEP 8 for Python.
* Check `.eslintrc` in the root folder of the project for Javascript styleguide.
